Index: /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/aeroptproperties.F90	(revision 253)
@@ -210,92 +387,297 @@
           grid_i=floor(var_tmp)
           IF (grid_i.GE.refftabsize) THEN
-           WRITE(*,*) 'Warning: Aerosol particle size in grid box #'
-           WRITE(*,*) ig,' is too large to be used by the '
-           WRITE(*,*) 'radiative transfer; please extend the '
-           WRITE(*,*) 'interpolation grid to larger sizes.'
-
+!           WRITE(*,*) 'Warning: particle size in grid box #'
+!           WRITE(*,*) ig,' is too large to be used by the '
+!           WRITE(*,*) 'radiative transfer; please extend the '
+!           WRITE(*,*) 'interpolation grid to larger grain sizes.'
             grid_i=refftabsize-1
             kx = 1.
           ELSEIF (grid_i.LT.1) THEN
-           WRITE(*,*) 'Warning: Aerosol particle size in grid box #'
-           WRITE(*,*) ig,' is too small to be used by the '
-           WRITE(*,*) 'radiative transfer; please extend the '
-           WRITE(*,*) 'interpolation grid to smaller sizes.'
+!           WRITE(*,*) 'Warning: particle size in grid box #'
+!           WRITE(*,*) ig,' is too small to be used by the '
+!           WRITE(*,*) 'radiative transfer; please extend the '
+!           WRITE(*,*) 'interpolation grid to smaller grain sizes.'
             grid_i=1
             kx = 0.
           ELSE
-            kx = ( reffrad(ig,lg,iaer)-refftab(grid_i) ) / &
-                ( refftab(grid_i+1)-refftab(grid_i) )
+            kx = ( reffrad(ig,lg,iaer)-refftab(grid_i) ) /            &
+                 ( refftab(grid_i+1)-refftab(grid_i) )
           ENDIF
 !         2.3 Integration
           DO j=grid_i,grid_i+1
-!             2.3.1 Check if the calculation has been completed
+!             2.3.1 Check if the calculation has been done
               IF (.NOT.checkgrid(j,1,iaer,idomain)) THEN
-!               2.3.2 Compute r_g and sigma_g for the log-normal
-!                 distribution as defined by [hansen_1974], "Light
-!                 scattering in planetary atmospheres", Space
-!                 Science Reviews 16 527-610, p558
-                sigma_g = log(1.+nueffrad(1,1,iaer))
-                r_g = exp(2.5*sigma_g)
-                sigma_g = sqrt(sigma_g)
-                r_g = refftab(j) / r_g
+!               2.3.2 Log-normal dist., r_g and sigma_g are defined
+!                 in [hansen_1974], "Light scattering in planetary
+!                 atmospheres", Space Science Reviews 16 527-610.
+!                 Here, sizedistk1=r_g and sizedistk2=sigma_g^2
+                sizedistk2 = log(1.+nueffrad(1,1,iaer))
+                sizedistk1 = exp(2.5*sizedistk2)
+                sizedistk1 = refftab(j) / sizedistk1
+
+                normd(j,1,iaer,idomain) = 1e-30
+                DO gausind=1,ngau
+                  drad=radiusr*radgaus(gausind)
+                  dista(j,1,iaer,idomain,gausind) = LOG((radiusm-drad)/sizedistk1)
+                  dista(j,1,iaer,idomain,gausind) =                   &
+                    EXP(-dista(j,1,iaer,idomain,gausind) *            &
+                    dista(j,1,iaer,idomain,gausind) *                 &
+                    0.5e0/sizedistk2)/(radiusm-drad)                  
+                  dista(j,1,iaer,idomain,gausind) =                   &
+                    dista(j,1,iaer,idomain,gausind) /                 &
+                    (sqrt(2e0*pi*sizedistk2))
+
+                  distb(j,1,iaer,idomain,gausind) = LOG((radiusm+drad)/sizedistk1)
+                  distb(j,1,iaer,idomain,gausind) =                   &
+                    EXP(-distb(j,1,iaer,idomain,gausind) *            &
+                    distb(j,1,iaer,idomain,gausind) *                 &
+                    0.5e0/sizedistk2)/(radiusm+drad)
+                  distb(j,1,iaer,idomain,gausind) =                   &
+                    distb(j,1,iaer,idomain,gausind) /                 &
+                    (sqrt(2e0*pi*sizedistk2))
+
+                  normd(j,1,iaer,idomain)=normd(j,1,iaer,idomain) +   &
+                    weightgaus(gausind) *                             &
+                    (                                                 &
+                    distb(j,1,iaer,idomain,gausind) * pi *            &
+                    radGAUSb(gausind,iaer,idomain) *                  &
+                    radGAUSb(gausind,iaer,idomain) +                  &
+                    dista(j,1,iaer,idomain,gausind) * pi *            &
+                    radGAUSa(gausind,iaer,idomain) *                  &
+                    radGAUSa(gausind,iaer,idomain)                    &
+                    )
+                ENDDO
                 IF (idomain.EQ.1) THEN ! VISIBLE DOMAIN -----------
 !                 2.3.3.vis Initialization
-                  epVISgrid(j,1,:,iaer)=0.
+                  qsqrefVISgrid(j,1,:,iaer)=0.
+                  qextVISgrid(j,1,:,iaer)=0.
+                  qscatVISgrid(j,1,:,iaer)=0.
                   omegVISgrid(j,1,:,iaer)=0.
                   gVISgrid(j,1,:,iaer)=0.
-                  eprefVISgrid(j,1,iaer)=0.
-!                 2.3.4.vis Log-normal distribution
-                  DO l=1,nsize(iaer,idomain)+1
-                    dfi_tmp(l) = log(radiusint(l)/r_g) /  &
-                                sqrt(2.)/sigma_g
+                  qrefVISgrid(j,1,iaer)=0.
+                  qscatrefVISgrid(j,1,iaer)=0.
+                  omegrefVISgrid(j,1,iaer)=0.
+
+                  DO gausind=1,ngau
+                    DO m=1,L_NSPECTV
+!                     Convolution:
+                      qextVISgrid(j,1,m,iaer) =              &
+                        qextVISgrid(j,1,m,iaer) +            & 
+                        weightgaus(gausind) *                &
+                        (                                    &
+                        qsqrefVISb(m,gausind,iaer) *         &
+                        qrefVISb(gausind,iaer) *             &
+                        pi*radGAUSb(gausind,iaer,idomain) *  &
+                        radGAUSb(gausind,iaer,idomain) *     &
+                        distb(j,1,iaer,idomain,gausind) +    &
+                        qsqrefVISa(m,gausind,iaer) *         &
+                        qrefVISa(gausind,iaer) *             &
+                        pi*radGAUSa(gausind,iaer,idomain) *  &
+                        radGAUSa(gausind,iaer,idomain) *     &
+                        dista(j,1,iaer,idomain,gausind)      &
+                        )
+                      qscatVISgrid(j,1,m,iaer) =             &
+                        qscatVISgrid(j,1,m,iaer) +           &
+                        weightgaus(gausind) *                &
+                        (                                    &
+                        omegVISb(m,gausind,iaer) *           &
+                        qsqrefVISb(m,gausind,iaer) *         &
+                        qrefVISb(gausind,iaer) *             &
+                        pi*radGAUSb(gausind,iaer,idomain) *  &
+                        radGAUSb(gausind,iaer,idomain) *     &
+                        distb(j,1,iaer,idomain,gausind) +    &
+                        omegVISa(m,gausind,iaer) *           &
+                        qsqrefVISa(m,gausind,iaer) *         &
+                        qrefVISa(gausind,iaer) *             &
+                        pi*radGAUSa(gausind,iaer,idomain) *  &
+                        radGAUSa(gausind,iaer,idomain) *     &
+                        dista(j,1,iaer,idomain,gausind)      &
+                        )
+                      gVISgrid(j,1,m,iaer) =                 &
+                        gVISgrid(j,1,m,iaer) +               &
+                        weightgaus(gausind) *                &
+                        (                                    &
+                        omegVISb(m,gausind,iaer) *           &
+                        qsqrefVISb(m,gausind,iaer) *         &
+                        qrefVISb(gausind,iaer) *             &
+                        gVISb(m,gausind,iaer) *              &
+                        pi*radGAUSb(gausind,iaer,idomain) *  &
+                        radGAUSb(gausind,iaer,idomain) *     &
+                        distb(j,1,iaer,idomain,gausind) +    &
+                        omegVISa(m,gausind,iaer) *           &
+                        qsqrefVISa(m,gausind,iaer) *         &
+                        qrefVISa(gausind,iaer) *             &
+                        gVISa(m,gausind,iaer) *              &
+                        pi*radGAUSa(gausind,iaer,idomain) *  &
+                        radGAUSa(gausind,iaer,idomain) *     &
+                        dista(j,1,iaer,idomain,gausind)      &
+                        )
+                    ENDDO
+                    qrefVISgrid(j,1,iaer) =                  &
+                      qrefVISgrid(j,1,iaer) +                &
+                      weightgaus(gausind) *                  &
+                      (                                      &
+                      qrefVISb(gausind,iaer) *               &
+                      pi*radGAUSb(gausind,iaer,idomain) *    &
+                      radGAUSb(gausind,iaer,idomain) *       &
+                      distb(j,1,iaer,idomain,gausind) +      &
+                      qrefVISa(gausind,iaer) *               &
+                      pi*radGAUSa(gausind,iaer,idomain) *    &
+                      radGAUSa(gausind,iaer,idomain) *       &
+                      dista(j,1,iaer,idomain,gausind)        &
+                      )
+                    qscatrefVISgrid(j,1,iaer) =              &
+                      qscatrefVISgrid(j,1,iaer) +            &
+                      weightgaus(gausind) *                  &
+                      (                                      &
+                      omegrefVISb(gausind,iaer) *            &
+                      qrefVISb(gausind,iaer) *               & 
+                      pi*radGAUSb(gausind,iaer,idomain) *    &
+                      radGAUSb(gausind,iaer,idomain) *       &
+                      distb(j,1,iaer,idomain,gausind) +      &
+                      omegrefVISa(gausind,iaer) *            &
+                      qrefVISa(gausind,iaer) *               &
+                      pi*radGAUSa(gausind,iaer,idomain) *    &
+                      radGAUSa(gausind,iaer,idomain) *       &
+                      dista(j,1,iaer,idomain,gausind)        &
+                      )
                   ENDDO
-                  DO l=1,nsize(iaer,idomain)
-                    dfi = 0.5*( derf(dfi_tmp(l+1)) -  &
-                               derf(dfi_tmp(l)) )
-                    DO m=1,L_NSPECTV
-                      epVISgrid(j,1,m,iaer) = &
-                               epVISgrid(j,1,m,iaer) &
-                               + QVISsQREF(m,iaer,l)*dfi
-                      omegVISgrid(j,1,m,iaer) = &
-                               omegVISgrid(j,1,m,iaer) &
-                               + omegaVIS(m,iaer,l)*dfi
-                      gVISgrid(j,1,m,iaer) = &
-                               gVISgrid(j,1,m,iaer)  &
-                               + gVIS(m,iaer,l)*dfi
-                    ENDDO !L_NSPECTV
-                    eprefVISgrid(j,1,iaer) =  &
-                               eprefVISgrid(j,1,iaer)  &
-                               + QREFvis(iaer,l)*dfi
-                  ENDDO !nsize
+
+                  qrefVISgrid(j,1,iaer)=qrefVISgrid(j,1,iaer) /          &
+                                normd(j,1,iaer,idomain)       
+                  qscatrefVISgrid(j,1,iaer)=qscatrefVISgrid(j,1,iaer) /  &
+                                normd(j,1,iaer,idomain)
+                  omegrefVISgrid(j,1,iaer)=qscatrefVISgrid(j,1,iaer) /   &
+                               qrefVISgrid(j,1,iaer)
+                  DO m=1,L_NSPECTV
+                    qextVISgrid(j,1,m,iaer)=qextVISgrid(j,1,m,iaer) /    &
+                                normd(j,1,iaer,idomain)
+                    qscatVISgrid(j,1,m,iaer)=qscatVISgrid(j,1,m,iaer) /  &
+                                normd(j,1,iaer,idomain)
+                    gVISgrid(j,1,m,iaer)=gVISgrid(j,1,m,iaer) /          &
+                                qscatVISgrid(j,1,m,iaer) /               &
+                                normd(j,1,iaer,idomain)
+
+                    qsqrefVISgrid(j,1,m,iaer)=qextVISgrid(j,1,m,iaer) /  &
+                                qrefVISgrid(j,1,iaer)
+                    omegVISgrid(j,1,m,iaer)=qscatVISgrid(j,1,m,iaer) /   &
+                                qextVISgrid(j,1,m,iaer)
+                  ENDDO
                 ELSE                   ! INFRARED DOMAIN ----------
 !                 2.3.3.ir Initialization
-                  epIRgrid(j,1,:,iaer)=0.
+                  qsqrefIRgrid(j,1,:,iaer)=0.
+                  qextIRgrid(j,1,:,iaer)=0.
+                  qscatIRgrid(j,1,:,iaer)=0.
                   omegIRgrid(j,1,:,iaer)=0.
                   gIRgrid(j,1,:,iaer)=0.
-                  eprefIRgrid(j,1,iaer)=0.
-!                 2.3.4.ir Log-normal distribution
-                  DO l=1,nsize(iaer,idomain)+1
-                    dfi_tmp(l) = log(radiusint(l)/r_g) / &
-                                sqrt(2.)/sigma_g
+                  qrefIRgrid(j,1,iaer)=0.
+                  qscatrefIRgrid(j,1,iaer)=0.
+                  omegrefIRgrid(j,1,iaer)=0.
+
+                  DO gausind=1,ngau
+                    DO m=1,L_NSPECTI
+!                     Convolution:
+                      qextIRgrid(j,1,m,iaer) =                  &
+                        qextIRgrid(j,1,m,iaer) +                &
+                        weightgaus(gausind) *                   &
+                        (                                       &
+                        qsqrefIRb(m,gausind,iaer) *             &
+                        qrefVISb(gausind,iaer) *                &
+                        pi*radGAUSb(gausind,iaer,idomain) *     &
+                        radGAUSb(gausind,iaer,idomain) *        &
+                        distb(j,1,iaer,idomain,gausind) +       &
+                        qsqrefIRa(m,gausind,iaer) *             &
+                        qrefVISa(gausind,iaer) *                &
+                        pi*radGAUSa(gausind,iaer,idomain) *     &
+                        radGAUSa(gausind,iaer,idomain) *        &
+                        dista(j,1,iaer,idomain,gausind)         &
+                        )
+                      qscatIRgrid(j,1,m,iaer) =                 &
+                        qscatIRgrid(j,1,m,iaer) +               &
+                        weightgaus(gausind) *                   &
+                        (                                       &
+                        omegIRb(m,gausind,iaer) *               &
+                        qsqrefIRb(m,gausind,iaer) *             &
+                        qrefVISb(gausind,iaer) *                &
+                        pi*radGAUSb(gausind,iaer,idomain) *     &
+                        radGAUSb(gausind,iaer,idomain) *        &
+                        distb(j,1,iaer,idomain,gausind) +       &
+                        omegIRa(m,gausind,iaer) *               &
+                        qsqrefIRa(m,gausind,iaer) *             &
+                        qrefVISa(gausind,iaer) *                &
+                        pi*radGAUSa(gausind,iaer,idomain) *     &
+                        radGAUSa(gausind,iaer,idomain) *        &
+                        dista(j,1,iaer,idomain,gausind)         &
+                        )
+                      gIRgrid(j,1,m,iaer) =                     &
+                        gIRgrid(j,1,m,iaer) +                   &
+                        weightgaus(gausind) *                   &
+                        (                                       &
+                        omegIRb(m,gausind,iaer) *               &
+                        qsqrefIRb(m,gausind,iaer) *             &
+                        qrefVISb(gausind,iaer) *                &
+                        gIRb(m,gausind,iaer) *                  &
+                        pi*radGAUSb(gausind,iaer,idomain) *     &
+                        radGAUSb(gausind,iaer,idomain) *        &
+                        distb(j,1,iaer,idomain,gausind) +       &
+                        omegIRa(m,gausind,iaer) *               &
+                        qsqrefIRa(m,gausind,iaer) *             &
+                        qrefVISa(gausind,iaer) *                &
+                        gIRa(m,gausind,iaer) *                  &
+                        pi*radGAUSa(gausind,iaer,idomain) *     &
+                        radGAUSa(gausind,iaer,idomain) *        &
+                        dista(j,1,iaer,idomain,gausind)         &
+                        )
+                    ENDDO
+                    qrefIRgrid(j,1,iaer) =                      &
+                      qrefIRgrid(j,1,iaer) +                    &
+                      weightgaus(gausind) *                     &
+                      (                                         &
+                      qrefIRb(gausind,iaer) *                   &
+                      pi*radGAUSb(gausind,iaer,idomain) *       &
+                      radGAUSb(gausind,iaer,idomain) *          &
+                      distb(j,1,iaer,idomain,gausind) +         &
+                      qrefIRa(gausind,iaer) *                   &
+                      pi*radGAUSa(gausind,iaer,idomain) *       &
+                      radGAUSa(gausind,iaer,idomain) *          &
+                      dista(j,1,iaer,idomain,gausind)           &
+                      )
+                    qscatrefIRgrid(j,1,iaer) =                  &
+                      qscatrefIRgrid(j,1,iaer) +                &
+                      weightgaus(gausind) *                     &
+                      (                                         &
+                      omegrefIRb(gausind,iaer) *                &
+                      qrefIRb(gausind,iaer) *                   &
+                      pi*radGAUSb(gausind,iaer,idomain) *       &
+                      radGAUSb(gausind,iaer,idomain) *          &
+                      distb(j,1,iaer,idomain,gausind) +         &
+                      omegrefIRa(gausind,iaer) *                &
+                      qrefIRa(gausind,iaer) *                   &
+                      pi*radGAUSa(gausind,iaer,idomain) *       &
+                      radGAUSa(gausind,iaer,idomain) *          &
+                      dista(j,1,iaer,idomain,gausind)           &
+                      )
                   ENDDO
-                  DO l=1,nsize(iaer,idomain)
-                    dfi = 0.5*( derf(dfi_tmp(l+1)) - &
-                               derf(dfi_tmp(l)) )
-                    DO m=1,L_NSPECTI
-                      epIRgrid(j,1,m,iaer) = &
-                               epIRgrid(j,1,m,iaer) &
-                               + QIRsQREF(m,iaer,l)*dfi
-                      omegIRgrid(j,1,m,iaer) = &
-                               omegIRgrid(j,1,m,iaer) &
-                               + omegaIR(m,iaer,l)*dfi
-                      gIRgrid(j,1,m,iaer) = &
-                               gIRgrid(j,1,m,iaer) &
-                               + gIR(m,iaer,l)*dfi
-                    ENDDO !L_NSPECTI
-                    eprefIRgrid(j,1,iaer) = &
-                               eprefIRgrid(j,1,iaer) &
-                               + QREFir(iaer,l)*dfi
-                  ENDDO !nsize
+ 
+                  qrefIRgrid(j,1,iaer)=qrefIRgrid(j,1,iaer) /          &
+                                normd(j,1,iaer,idomain)
+                  qscatrefIRgrid(j,1,iaer)=qscatrefIRgrid(j,1,iaer) /  &
+                                normd(j,1,iaer,idomain)
+                  omegrefIRgrid(j,1,iaer)=qscatrefIRgrid(j,1,iaer) /   &
+                               qrefIRgrid(j,1,iaer)
+                  DO m=1,L_NSPECTI
+                    qextIRgrid(j,1,m,iaer)=qextIRgrid(j,1,m,iaer) /    &
+                                normd(j,1,iaer,idomain)
+                    qscatIRgrid(j,1,m,iaer)=qscatIRgrid(j,1,m,iaer) /  &
+                                normd(j,1,iaer,idomain)
+                    gIRgrid(j,1,m,iaer)=gIRgrid(j,1,m,iaer) /          &
+                                qscatIRgrid(j,1,m,iaer) /              &
+                                normd(j,1,iaer,idomain)
+
+                    qsqrefIRgrid(j,1,m,iaer)=qextIRgrid(j,1,m,iaer) /  &
+                                qrefVISgrid(j,1,iaer)
+                    omegIRgrid(j,1,m,iaer)=qscatIRgrid(j,1,m,iaer) /   &
+                                qextIRgrid(j,1,m,iaer)
+                  ENDDO
                 ENDIF                  ! --------------------------
                 checkgrid(j,1,iaer,idomain) = .true.
@@ -307,53 +689,56 @@
           IF (idomain.EQ.1) THEN ! VISIBLE ------------------------
           DO m=1,L_NSPECTV
-            QVISsQREF3d(ig,lg,m,iaer) = &
-                       k1*epVISgrid(grid_i,1,m,iaer) + &
-                       k2*epVISgrid(grid_i+1,1,m,iaer)
-            omegaVIS3d(ig,lg,m,iaer) = &
-                       k1*omegVISgrid(grid_i,1,m,iaer) + &
-                       k2*omegVISgrid(grid_i+1,1,m,iaer)
-            gVIS3d(ig,lg,m,iaer) = &
-                       k1*gVISgrid(grid_i,1,m,iaer) + &
-                       k2*gVISgrid(grid_i+1,1,m,iaer)
+             QVISsQREF3d(ig,lg,m,iaer) =                           &
+                        k1*qsqrefVISgrid(grid_i,1,m,iaer) +        &
+                        k2*qsqrefVISgrid(grid_i+1,1,m,iaer)
+            omegaVIS3d(ig,lg,m,iaer) =                             &
+                        k1*omegVISgrid(grid_i,1,m,iaer) +          &
+                        k2*omegVISgrid(grid_i+1,1,m,iaer)
+            gVIS3d(ig,lg,m,iaer) =                                 &
+                        k1*gVISgrid(grid_i,1,m,iaer) +             &
+                        k2*gVISgrid(grid_i+1,1,m,iaer)
           ENDDO !L_NSPECTV
-          QREFvis3d(ig,lg,iaer) = &
-                       k1*eprefVISgrid(grid_i,1,iaer) + &
-                       k2*eprefVISgrid(grid_i+1,1,iaer)
+          QREFvis3d(ig,lg,iaer) =                                  &
+                        k1*qrefVISgrid(grid_i,1,iaer) +            &
+                        k2*qrefVISgrid(grid_i+1,1,iaer)
+          omegaREFvis3d(ig,lg,iaer) =                              &
+                        k1*omegrefVISgrid(grid_i,1,iaer) +         &
+                        k2*omegrefVISgrid(grid_i+1,1,iaer)
           ELSE                   ! INFRARED -----------------------
           DO m=1,L_NSPECTI
-            QIRsQREF3d(ig,lg,m,iaer) = &
-                       k1*epIRgrid(grid_i,1,m,iaer) + &
-                       k2*epIRgrid(grid_i+1,1,m,iaer)
-            omegaIR3d(ig,lg,m,iaer) = &
-                       k1*omegIRgrid(grid_i,1,m,iaer) + &
-                       k2*omegIRgrid(grid_i+1,1,m,iaer)
-            gIR3d(ig,lg,m,iaer) = &
-                       k1*gIRgrid(grid_i,1,m,iaer) + &
-                       k2*gIRgrid(grid_i+1,1,m,iaer)
+            QIRsQREF3d(ig,lg,m,iaer) =                             &
+                        k1*qsqrefIRgrid(grid_i,1,m,iaer) +         &
+                        k2*qsqrefIRgrid(grid_i+1,1,m,iaer)
+            omegaIR3d(ig,lg,m,iaer) =                              &
+                        k1*omegIRgrid(grid_i,1,m,iaer) +           &
+                        k2*omegIRgrid(grid_i+1,1,m,iaer) 
+            gIR3d(ig,lg,m,iaer) =                                  & 
+                        k1*gIRgrid(grid_i,1,m,iaer) +              &
+                        k2*gIRgrid(grid_i+1,1,m,iaer)
           ENDDO !L_NSPECTI
-          QREFir3d(ig,lg,iaer) = &
-                       k1*eprefIRgrid(grid_i,1,iaer) + &
-                       k2*eprefIRgrid(grid_i+1,1,iaer)
+          QREFir3d(ig,lg,iaer) =                                   &
+                        k1*qrefIRgrid(grid_i,1,iaer) +             &
+                        k2*qrefIRgrid(grid_i+1,1,iaer)
+          omegaREFir3d(ig,lg,iaer) =                               &
+                        k1*omegrefIRgrid(grid_i,1,iaer) +          &
+                        k2*omegrefIRgrid(grid_i+1,1,iaer)
           ENDIF                  ! --------------------------------
         ENDDO !nlayermx
       ENDDO !ngridmx
 
+!==================================================================
+
+
+
       ENDDO ! idomain
 
-
-        ENDIF ! nsize = 1
+      ENDIF ! nsize = 1
+
       ENDDO ! iaer (loop on aerosol kind)
 
-!      open(116,file='QIRsQREF3dO.dat')
-!      write(116,*) QIRsQREF3d
-!      close(116)
-!      open(117,file='omegaIR3dO.dat')
-!      write(117,*) omegaIR3d
-!      close(117)
-!      open(118,file='gIR3dO.dat')
-!      write(118,*) gIR3d
-!      close(118)
-!      stop
-
       RETURN
-    END subroutine aeroptproperties
+    END SUBROUTINE aeroptproperties
+
+
+
+      
Index: /trunk/LMDZ.GENERIC/libf/phystd/ave_stelspec.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/ave_stelspec.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/ave_stelspec.F90	(revision 253)
@@ -1,3 +1,3 @@
-      subroutine ave_stelspec(startype,STELLAR)
+      subroutine ave_stelspec(STELLAR)
 
 !==================================================================
@@ -28,7 +28,8 @@
 
 #include "datafile.h"
+#include "callkeys.h"
 
       real*8 STELLAR(L_NSPECTV)
-      integer startype 
+!      integer startype 
 
       integer Nfine
@@ -43,4 +44,7 @@
       character(len=50)  :: file_id
       character(len=100) :: file_path
+
+      real lam_temp
+      double precision stel_temp
 
       STELLAR(:)=0.0
@@ -58,33 +62,44 @@
       dl=lam(2)-lam(1)
 
-      ! load high resolution stellar data
-      if(startype.eq.1)then
-         file_id='/stellar_spectra/sol.txt'
-         tstellar=5800.
-      elseif(startype.eq.2)then
-         file_id='/stellar_spectra/gl581.txt'
-         tstellar=3200.
-      elseif(startype.eq.3)then
-         file_id='/stellar_spectra/adleo.txt'
-         tstellar=3200.
-      elseif(startype.eq.4)then
-         file_id='/stellar_spectra/gj644.txt'
-         print*,'Find out tstellar before using this star!'
-         call abort
-      elseif(startype.eq.5)then
-         file_id='/stellar_spectra/hd128167.txt'
-         tstellar=6700. ! Segura et al. (2003)
+
+      if(stelbbody)then
+         tstellar=stelTbb
+         do ifine=1,Nfine
+            lam_temp=lam(ifine)
+            call blackl(dble(lam_temp*1e-6),dble(tstellar),stel_temp)
+            stel_f(ifine)=stel_temp
+         enddo
       else
-         print*,'Error: unknown star type chosen'
-         call abort
+         ! load high resolution stellar data
+         if(startype.eq.1)then
+            file_id='/stellar_spectra/sol.txt'
+            tstellar=5800.
+         elseif(startype.eq.2)then
+            file_id='/stellar_spectra/gl581.txt'
+            tstellar=3200.
+         elseif(startype.eq.3)then
+            file_id='/stellar_spectra/adleo.txt'
+            tstellar=3200.
+         elseif(startype.eq.4)then
+            file_id='/stellar_spectra/gj644.txt'
+            print*,'Find out tstellar before using this star!'
+            call abort
+         elseif(startype.eq.5)then
+            file_id='/stellar_spectra/hd128167.txt'
+            tstellar=6700. ! Segura et al. (2003)
+         else
+            print*,'Error: unknown star type chosen'
+            call abort
+         endif
+         file_path=datafile(1:LEN_TRIM(datafile))//file_id(1:LEN_TRIM(file_id))
+
+         open(111,file=file_path,form='formatted')
+         do ifine=1,Nfine
+            read(111,*) stel_f(ifine)
+         enddo
+         close(111)
       endif
-      file_path=datafile(1:LEN_TRIM(datafile))//file_id(1:LEN_TRIM(file_id))
 
-      open(111,file=file_path,form='formatted')
-      do ifine=1,Nfine
-         read(111,*) stel_f(ifine)
-      enddo
-      close(111)
-      
+
       ! sum data by band
       band=1
@@ -104,3 +119,4 @@
       STELLAR=STELLAR/sum(STELLAR)
 
+
       end subroutine ave_stelspec
Index: /trunk/LMDZ.GENERIC/libf/phystd/blackl.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/blackl.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/blackl.F	(revision 253)
@@ -1,7 +1,7 @@
       subroutine blackl(blalong,blat,blae)
-c.......................................................................
+
       implicit double precision (a-h,o-z)
-c.......................................................................
-c.....donnees de fond
+
+      ! physical constants
       sigma=5.6693d-08
       pi=datan(1.d0)*4.d0
@@ -13,8 +13,9 @@
       c1=h*(c**2)
       c2=h*c/cbol
-c.....fin de donnees de fond
-c.......................................................................
+
+
       blae=2.d0*pi*c1/blalong**5/(dexp(c2/blalong/blat)-1.d0)
-c.......................................................................
+
+
       return
       end
Index: /trunk/LMDZ.GENERIC/libf/phystd/calc_cpp3d.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/calc_cpp3d.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/calc_cpp3d.F90	(revision 253)
@@ -13,26 +13,19 @@
 !==================================================================
 
-        ! you still need to validate this equation vs something....
-
       implicit none
 
 #include "comcstfi.h"
+#include "callkeys.h"
+#include "cpdet.h"
 
-      real cp0, dB2dT2
+      !real cp0, dB2dT2
       real cppNI      ! specific heat capacity at const. pressure
       real rcpNI      ! R / specific heat capacity
       real t
       real p
-      real calmol
-      real bar
 
-      calmol = 94.9784 ! 4.18/(mco2/1000)
-      bar    = 100000
+      ! dummy function until I decide what to do!
 
-      cp0    = (7.70+5.3e-3*t - 8.3e-7*t**2)*calmol
-      dB2dT2 = 2.69e-5*t - 0.0098
-      cppNI  = cp0 - t*(p/bar)*dB2dT2
-      !cppNI  = 1000*(t/460)**0.35 ! Sebastian's version
-
+      cppNI  = cpp
       rcpNI  = R/cppNI
 
